/***********************************************}
{       Simple DEMO Program for using           }
{                                               }
{           Expression Parser                   }
{       for  C++ Builder 3.0 and 4.0            }
{                                               }
{           by Todor Marholev                   }
{       e-mail: spsoft@mail.vega.bg             }
{***********************************************/

//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "Unit2.h"
#include "math.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "ExPars"
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
}
void __fastcall _MySum(PParserOperation AnOper)
{
   for (int i = 1; i<=AnOper->ArgCnt; i++)
   {
     switch (i){
       case 1: *(AnOper->Dest) = *(AnOper->Arg1);
               break;
       case 2: *(AnOper->Dest) += *(AnOper->Arg2);
               break;
       case 3: *(AnOper->Dest) += *(AnOper->Arg3);
               break;
       default: *(AnOper->Dest) += *((AnOper->Args)[i-4]);
     }
   }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
   ExParser1->AddFunction("MySum",_MySum, -1/*Unlimited number of arguments*/);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
   ExParser1->EditVariables();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button2Click(TObject *Sender)
{
   EPUserLib1->Edit();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button4Click(TObject *Sender)
{
   EPUserLib1->IniFile = "";
   //If a Path is not specified, INI file must be in the Windows directory
   EPUserLib1->IniFile = "DEMOLIB.INI";
}
//---------------------------------------------------------------------------

void AddUserLibExpr(TEPExprList *AList, AnsiString AName, AnsiString AExpr)
{
  TStrings *ASrc;
  int AnIdx;
  ASrc = new TStringList;
  try
    {
    ASrc->Add(AExpr);
    if (AList->Find(AName,AnIdx)) AList->Sources[AnIdx]=ASrc;
    else AList->Add(AName,ASrc);
    }
  __finally { delete ASrc; }
}

void __fastcall TForm1::Button5Click(TObject *Sender)
{
  ExParser1->Variable["x1"] = 4;
  ExParser1->Variable["y1"] = 3;
  AddUserLibExpr(EPUserLib1->Aliases,"x","%0");
  EPUserLib1->Aliases->AddExpr("y","%1");
  EPUserLib1->Aliases->AddExpr("z","%2");
  EPUserLib1->UserFuncs->AddExpr("LibFunc1","x + y^3");
  EPUserLib1->UserFuncs->AddExpr("LibFunc2","LibFunc1(x,y)^2");
  Edit1->Text="x1 ^ y1 + MySum(MyFunc(x,y,z),MyFunc(x+4,y+1,z+9),prod(x2,y2),"
               "MyFunc1(x2,y2),LibFunc2(x2,y2),x3^y3)";
}
//---------------------------------------------------------------------------


void __fastcall TForm1::Button6Click(TObject *Sender)
{
  if (CompareText(ExParser1->Expr,Edit1->Text)!=0) ExParser1->Expr=Edit1->Text;
  ResultLbl->Caption=FloatToStr(ExParser1->F(OPENARRAY(long double,(3,2,4))));
}
//---------------------------------------------------------------------------


Extended __fastcall TForm1::ExParser1Variable(TObject *Sender,
      const AnsiString VarName)
{
   int AnIdx;
   if (VarName==UpperCase("x2")) return 5;
   else if (VarName=="Y2") return 3;
   if (VarName==UpperCase("x2")) return 5;
   else if (ExParser1->UsedVariables->Find(VarName,AnIdx))
     return ExParser1->UsedVariables->Value[AnIdx];
   else return 0;
}
//---------------------------------------------------------------------------

Extended __fastcall TForm1::ExParser1Function(TObject *Sender,
      const AnsiString FuncName, const ArgArray &FuncParams,
      const int Param_High)
{
   Extended Result = 0;
   if (FuncName==UpperCase("MyFunc"))
      Result=FuncParams[0]*FuncParams[1]+FuncParams[2];
   else if (FuncName==UpperCase("MyFunc1"))
      Result=pow(FuncParams[0],2)+FuncParams[1];
   else if (FuncName==UpperCase("MySumFunc"))
     for (int i=0; i<=Param_High; i++) Result+=FuncParams[i];
   return Result;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button3Click(TObject *Sender)
{
   TUsedVarsEditDlg *ADlg;
   if (CompareText(ExParser1->Expr,Edit1->Text)!=0) ExParser1->Expr=Edit1->Text;
   ADlg = new TUsedVarsEditDlg(this);
   try
     {
     ADlg->AnExParser=ExParser1;
     ADlg->ShowModal();
     }
   __finally { delete ADlg; };
}
//---------------------------------------------------------------------------

