// Borland C++ Builder
// Copyright (c) 1995, 1999 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'ExPars.pas' rev: 4.00

#ifndef ExParsHPP
#define ExParsHPP

#pragma delphiheader begin
#pragma option push -w-
#include <Classes.hpp>	// Pascal unit
#include <parstype.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Expars
{
//-- type declarations -------------------------------------------------------
typedef void __fastcall (__closure *TParserExceptionEvent)(System::TObject* Sender, Sysutils::Exception* 
	E);

typedef Extended __fastcall (__closure *TGetVariableEvent)(System::TObject* Sender, const AnsiString 
	VarName);

typedef Extended __fastcall (__closure *TGetFunctionEvent)(System::TObject* Sender, const AnsiString 
	FuncName, const Extended * FuncParams, const int Param_High);

#pragma option push -b-
enum TParsNotify { pnInvalidate, pnValidate, pnUncondValidate };
#pragma option pop

class DELPHICLASS TEvalObj;
class DELPHICLASS TCustomParser;
class DELPHICLASS TEPUserLib;
class DELPHICLASS TEPExprList;
#pragma pack(push, 4)
class PASCALIMPLEMENTATION TEPExprList : public Classes::TList 
{
	typedef Classes::TList inherited;
	
private:
	TEPUserLib* FLib;
	AnsiString __fastcall GetName(int AIdx);
	void __fastcall SetName(int AIdx, AnsiString AName);
	Classes::TStrings* __fastcall GetSource(int AIdx);
	void __fastcall SetSource(int AIdx, Classes::TStrings* ASource);
	int __fastcall GetArgCount(int AIdx);
	bool __fastcall IsReferenced(TEvalObj* AFunc);
	void __fastcall Validate(bool UnCond);
	void __fastcall Invalidate(void);
	
public:
	__fastcall virtual ~TEPExprList(void);
	void __fastcall ClearEntries(void);
	HIDESBASE void __fastcall Add(AnsiString AName, Classes::TStrings* ASource);
	void __fastcall AddExpr(AnsiString AName, AnsiString AnExpr);
	bool __fastcall Find(AnsiString AName, int &AIdx);
	HIDESBASE int __fastcall IndexOf(AnsiString AName);
	void __fastcall RemoveFunc(TEvalObj* AFunc);
	__property int ArgCount[int AIdx] = {read=GetArgCount};
	__property AnsiString Names[int AIdx] = {read=GetName, write=SetName};
	__property Classes::TStrings* Sources[int AIdx] = {read=GetSource, write=SetSource};
public:
	#pragma option push -w-inl
	/* TObject.Create */ inline __fastcall TEPExprList(void) : Classes::TList() { }
	#pragma option pop
	
};

#pragma pack(pop)

#pragma pack(push, 4)
class PASCALIMPLEMENTATION TEPUserLib : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	Classes::TStringList* FBuildFuncs;
	TEPExprList* FAliases;
	TEPExprList* FUserFuncs;
	AnsiString FIniFile;
	bool FDateFuncs;
	bool FExpLogFuncs;
	bool FTrigonomFuncs;
	int FUpdateCount;
	void __fastcall AdjustBuildInFuncs(void);
	void __fastcall ReadFuncs(Classes::TReader* Reader);
	void __fastcall WriteFuncs(Classes::TWriter* Writer);
	void __fastcall ReadAliases(Classes::TReader* Reader);
	void __fastcall WriteAliases(Classes::TWriter* Writer);
	void __fastcall SetIniFile(AnsiString AFName);
	int __fastcall IndexOfIdent(AnsiString AName, int &AType);
	void __fastcall SetDateFuncs(bool Value);
	void __fastcall SetExpLogFuncs(bool Value);
	void __fastcall SetTrigonomFuncs(bool Value);
	
protected:
	virtual void __fastcall DefineProperties(Classes::TFiler* Filer);
	virtual void __fastcall Loaded(void);
	bool __fastcall IsReferenced(TEvalObj* AFunc);
	void __fastcall NotifyParsers(TParsNotify ANotify);
	
public:
	__fastcall virtual TEPUserLib(Classes::TComponent* AOwner);
	__fastcall virtual ~TEPUserLib(void);
	void __fastcall AddFunction(const AnsiString AFunctionName, const Parstype::TMathProcedure Func, int 
		AnArgCnt);
	void __fastcall ClearBuildFunctions(void);
	void __fastcall ClearBuildFunction(const AnsiString AFunctionName);
	void __fastcall BeginUpdate(void);
	void __fastcall EndUpdate(void);
	void __fastcall Validate(bool UnCond);
	void __fastcall Invalidate(void);
	void __fastcall Edit(void);
	void __fastcall ReadUserLibFrom(AnsiString AnIniFile);
	void __fastcall WriteUserLibTo(AnsiString AnIniFile);
	__property TEPExprList* Aliases = {read=FAliases};
	__property TEPExprList* UserFuncs = {read=FUserFuncs};
	
__published:
	__property AnsiString IniFile = {read=FIniFile, write=SetIniFile};
	__property bool DateFuncs = {read=FDateFuncs, write=SetDateFuncs, default=1};
	__property bool ExpLogarithmFuncs = {read=FExpLogFuncs, write=SetExpLogFuncs, default=1};
	__property bool TrigonomFuncs = {read=FTrigonomFuncs, write=SetTrigonomFuncs, default=1};
};

#pragma pack(pop)

#pragma pack(push, 4)
class PASCALIMPLEMENTATION TCustomParser : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	TEvalObj* FFuncObj;
	Parstype::TVariables* FGlobalVars;
	Parstype::TVariables* FUndefVars;
	Parstype::TVariableList* FUsedVars;
	Classes::TStringList* FBuildFuncs;
	TEPUserLib* FUserLib;
	bool FDateFuncs;
	bool FExpLogFuncs;
	bool FTrigonomFuncs;
	TGetVariableEvent FOnVariable;
	TGetFunctionEvent FOnFunction;
	void __fastcall AdjustBuildInFuncs(void);
	bool __fastcall GetParserError(void);
	int __fastcall GetArgCount(void);
	void __fastcall SetUserLib(TEPUserLib* ALib);
	Classes::TStrings* __fastcall GetExpression(void);
	AnsiString __fastcall GetExpr(void);
	Parstype::TVariableList* __fastcall GetUsedVars(void);
	void __fastcall ClearUndefVariables(void);
	void __fastcall SetDateFuncs(bool Value);
	void __fastcall SetExpLogFuncs(bool Value);
	void __fastcall SetTrigonomFuncs(bool Value);
	void __fastcall SetExpression(Classes::TStrings* AnExpression);
	void __fastcall SetExpr(AnsiString AnExpr);
	void __fastcall SetVar(const AnsiString VarName, const Extended Value);
	void __fastcall SetVariables(Parstype::TVariables* AVarList);
	
protected:
	virtual void __fastcall Notification(Classes::TComponent* AComponent, Classes::TOperation Operation
		);
	virtual void __fastcall NotifyParser(Classes::TComponent* AComponent, TParsNotify ANotify);
	virtual void __fastcall Loaded(void);
	
public:
	__fastcall virtual TCustomParser(Classes::TComponent* AOwner);
	__fastcall virtual ~TCustomParser(void);
	Extended __fastcall GetVariable(const AnsiString VarName);
	Parstype::PParserFloat __fastcall SetVariable(AnsiString VarName, const Extended Value);
	void __fastcall AddFunction(const AnsiString AFunctionName, const Parstype::TMathProcedure Func, int 
		AnArgCnt);
	void __fastcall EditVariables(void);
	void __fastcall ClearVariables(void);
	void __fastcall ClearVariable(const AnsiString AVarName);
	bool __fastcall VariableExists(const AnsiString AVarName);
	void __fastcall ClearBuildFunctions(void);
	void __fastcall ClearBuildFunction(const AnsiString AFunctionName);
	void __fastcall InvalidateOperation(void);
	void __fastcall ValidateOperation(bool UnCond);
	__property int ArgCount = {read=GetArgCount, nodefault};
	virtual Extended __fastcall F(const Extended * AParams, const int AParams_Size);
	void __fastcall DoCheck(void);
	bool __fastcall Check(bool IsSilent);
	__property Classes::TStringList* BuildFuncs = {read=FBuildFuncs};
	__property AnsiString Expr = {read=GetExpr, write=SetExpr};
	__property bool ExprError = {read=GetParserError, nodefault};
	__property Parstype::TVariableList* UsedVariables = {read=GetUsedVars};
	__property Extended Variable[AnsiString VarName] = {read=GetVariable, write=SetVar};
	
__published:
	__property bool DateFuncs = {read=FDateFuncs, write=SetDateFuncs, default=1};
	__property bool ExpLogarithmFuncs = {read=FExpLogFuncs, write=SetExpLogFuncs, default=1};
	__property Classes::TStrings* Expression = {read=GetExpression, write=SetExpression};
	__property bool TrigonomFuncs = {read=FTrigonomFuncs, write=SetTrigonomFuncs, default=1};
	__property Parstype::TVariables* Variables = {read=FGlobalVars, write=SetVariables};
	__property TEPUserLib* UserLib = {read=FUserLib, write=SetUserLib};
	__property TGetVariableEvent OnVariable = {read=FOnVariable, write=FOnVariable};
	__property TGetFunctionEvent OnFunction = {read=FOnFunction, write=FOnFunction};
};

#pragma pack(pop)

#pragma pack(push, 4)
class PASCALIMPLEMENTATION TEvalObj : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	TCustomParser* FParser;
	TEPUserLib* FLib;
	int FArgCnt;
	Parstype::PParserFloat *FArgs;
	Classes::TList* FConstList;
	Parstype::TParserOperation *FOperList;
	char *FExpr;
	char *FSourceStr;
	bool FIsValid;
	bool FParserError;
	AnsiString FName;
	Classes::TStrings* FSource;
	bool FIsChecked;
	bool FValidating;
	Extended __fastcall CalcValue(void);
	bool __fastcall CheckOperList(void);
	bool __fastcall Check(void);
	int __fastcall GetArgCount(void);
	void __fastcall SetName(AnsiString AName);
	void __fastcall SetSource(Classes::TStrings* ASource);
	void __fastcall FreeExpression(void);
	void __fastcall ParseSource(void);
	void __fastcall ParseAliases(void);
	bool __fastcall ParseExpression(void);
	char * __fastcall GetExpr(void);
	AnsiString __fastcall GetSourceStr(void);
	void __fastcall SetSourceStr(AnsiString AStr);
	void __fastcall SourceChanged(System::TObject* Sender);
	__property AnsiString ExprStr = {read=GetSourceStr, write=SetSourceStr};
	
protected:
	__property char * Expression = {read=GetExpr};
	
public:
	__fastcall TEvalObj(void);
	__fastcall virtual ~TEvalObj(void);
	void __fastcall InvalidateOperation(void);
	void __fastcall ValidateOperation(bool UnCond);
	virtual Extended __fastcall F(const Extended * AParams, const int AParams_Size);
	__property char * SourceStr = {read=FSourceStr};
	__property int ArgCount = {read=GetArgCount, nodefault};
	__property AnsiString ExprName = {read=FName, write=SetName};
	__property Classes::TStrings* ExprSource = {read=FSource, write=SetSource};
};

#pragma pack(pop)

class DELPHICLASS TExParser;
#pragma pack(push, 4)
class PASCALIMPLEMENTATION TExParser : public TCustomParser 
{
	typedef TCustomParser inherited;
	
public:
	#pragma option push -w-inl
	/* TCustomParser.Create */ inline __fastcall virtual TExParser(Classes::TComponent* AOwner) : TCustomParser(
		AOwner) { }
	#pragma option pop
	#pragma option push -w-inl
	/* TCustomParser.Destroy */ inline __fastcall virtual ~TExParser(void) { }
	#pragma option pop
	
};

#pragma pack(pop)

typedef TExParser TExprParser;
;

//-- var, const, procedure ---------------------------------------------------

}	/* namespace Expars */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Expars;
#endif
#pragma option pop	// -w-

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// ExPars
